// Filename           : CLICTD_comparator.sv
// Author             : Núria Egidos 
// Created on         : 21/6/18
// Last modification  : 21/6/18
// Project            : Doctoral student, verification of CLICTD
// Description        : Comparator

`ifndef __CLICTD_comparator_sv__
`define __CLICTD_comparator_sv__

//import uvm_pkg::*;
//`include <uvm_macros.svh>

// This comparator assumes in-order arrival of transactions, i.e. the order of 
// arrival of a transaction from the predictor/golden model matches the order of 
// arrival of a transaction generated by the monitor probing the outputs


// This structure will enable having more than one export in the same scoreboard; 
// when the respective anlaysis ports call write(), the factory will automatically invoke 
// write_ideal() for the export associated to the port probing the expected outputs from the
// golden model, or write_actual() for the export associated to the port probing the actual
// outputs, depending on which of the ports is calling
`uvm_analysis_imp_decl(_ideal)
`uvm_analysis_imp_decl(_actual)




class CLICTD_comparator extends uvm_component;
	`uvm_component_utils(CLICTD_comparator) // Register the component to the factory


  string testname;

  CLICTDevents events_obj;
  ChipStatusInfo chip_status_obj;


  int number_discrepancies [chip_status_type];
  int number_transactions_evaluated [chip_status_type];

	// - - - - - - - - - - - - Constructor
	function new(string name, uvm_component parent);
		super.new(name, parent);
	endfunction: new


  // - - - - - - - - - - - - Build phase: build the hierarchy
	function void build_phase(uvm_phase phase);
		super.build_phase(phase);
    
    if( !uvm_config_db#(string)::get(this, "", "testname", testname) )
       `uvm_error( `NOTESTNAME, $sformatf("Testname not found in database for %s", this.get_full_name()) )

    // Retrieve the chip status from the database; it is set (and changed as the test progresses) from the virtual sequence 
    // in its body() task, so by this point it should be available to be retrieved
    if( !uvm_config_db#(ChipStatusInfo)::get(this, "", "chip_status_obj", chip_status_obj) )
        `uvm_error( `NOCHIPSTATUS, $sformatf("chip_status_obj not found in database for %s", this.get_full_name()) )

    if( !uvm_config_db#(CLICTDevents)::get(this, "", "events_obj", events_obj) )
         `uvm_error( `NOCLICTDEVENTS, $sformatf("CLICTDevents not found in database for %s", this.get_full_name()) )

	endfunction: build_phase

  // - - - - - - - - - - - - Increment number of discrepancies between transactions compared
  // Function to increment the number of discrepancies, called when some miscomparison is detected;
  // the increment is only performed if some transaction has already been evaluated
  function void increment_number_discrepancies();
           if ( number_transactions_evaluated [chip_status_obj.chip_status] > 0 ) begin
                number_discrepancies[chip_status_obj.chip_status] = number_discrepancies[chip_status_obj.chip_status] + 1; 
                //$display("%t increment - number discrepancies = %d, trans evaluated = %d",$realtime,number_discrepancies[chip_status_obj.chip_status],number_transactions_evaluated [chip_status_obj.chip_status]);
           end
  endfunction: increment_number_discrepancies


endclass: CLICTD_comparator



`endif // __CLICTD_comparator_sv__

